import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import javax.swing.JOptionPane;
import java.net.*;

public class TetrisShape extends ArrayList<Rectangle>
{
	private Random rand = new Random();
	private int type;
	private int state;
	public TetrisShape()
	{
		super();
		type = rand.nextInt(7);
		state = 0;
		makeShape();
	}
	public TetrisShape(TetrisShape ts)
	{
		super(ts);
		type = rand.nextInt(7);
		state = 0;
		makeShape();
	}
	
	
	public void moveUp()
	{
		for(Rectangle r:this)
			r.y-=30;
	}
	public void moveDown()
	{
		for(Rectangle r:this)
			r.y+=30;
	}
	public void moveRight()
	{
		for(Rectangle r:this)
			r.x+=30;
	}
	public void moveLeft()
	{
		for(Rectangle r:this)
			r.x-=30;
	}
	public int getType()
	{
		return type;
	}
	public void setLocation(Point p)
	{
		ArrayList<Rectangle> lowests = new ArrayList();
		ArrayList<Point> differences = new ArrayList();
		Rectangle lowest =  new Rectangle();
		for (Rectangle r:this)
		{
			if (r.y > lowest.y)
				lowest = r;				
		}
		for (Rectangle r:this)
		{
			Point diff = new Point(lowest.x-r.x, lowest.y-r.y);	
			r.setLocation(p.x-diff.x, p.y-diff.y);
		}	
	}
	
	private void makeShape()
	{
		for (int i = 0; i < 4; i++)
		{
			add(new Rectangle(30,30));
		}
		get(0).setLocation (150,-30);

		Rectangle firstRect = this.get(0);		
		switch(type)
		{
			case 0:
				this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
				this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
				this.get(3).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()+30);
			break;
			case 1:
				this.get(1).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
				this.get(2).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
				this.get(3).setLocation((int)firstRect.getX(),(int) firstRect.getY()+30);
			break;			
			case 2:
				this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
				this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
				this.get(3).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()+30);			
			break;
			case 3:
				this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
				this.get(2).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()+30);
				this.get(3).setLocation((int)firstRect.getX(),(int) firstRect.getY()+30);			
			break;
			case 4:
				this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
				this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
				this.get(3).setLocation((int)firstRect.getX()+90,(int) firstRect.getY());
			break;
			case 5:
				this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
				this.get(2).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()+30);
				this.get(3).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()+30);
			break;
			case 6:
				this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()-30);
				this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()-30);
				this.get(3).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
			break;
		}
	}
	
	
	public void rotateShape()
	{
		state = (state+1)%4;
		Rectangle firstRect = this.get(0);
		switch(type)
		{
			case 0:		
				switch(state)
				{
					case 0:
						System.out.println("0");
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()+30);
					break;
					case 1:
						firstRect.setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
						this.get(3).setLocation((int)firstRect.getX()-30, (int) firstRect.getY()+60);
					break;
					case 2:
						firstRect.setLocation((int)firstRect.getX()-30, (int) firstRect.getY());
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(2).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()+30);
						this.get(3).setLocation((int)firstRect.getX()+60, (int) firstRect.getY()+30);		
					break;
					case 3:
						this.get(1).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(3).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
					break;
				}
			break;
			case 1:
				switch (state)
				{
					case 0:
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX(),(int) firstRect.getY()+30);
					break;
					case 1:
						firstRect.setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
						this.get(3).setLocation((int)firstRect.getX()-30, (int) firstRect.getY());
					break;
					case 2:
						firstRect.setLocation((int)firstRect.getX()-30, (int) firstRect.getY()+30);
						this.get(1).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+60, (int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+60, (int) firstRect.getY()-30);		
					break;
					case 3:
						firstRect.setLocation((int)firstRect.getX(), (int) firstRect.getY()-30);
						this.get(1).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()+60);
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(3).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
					break;
				}
			break;			
			case 2:
				switch(state)
				{
					case 0:
						firstRect.setLocation((int)firstRect.getX()-30, (int) firstRect.getY());
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()+30);			
					break;
					case 1:
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
						this.get(3).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()+30);
					break;
					case 2:
						firstRect.setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(1).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+60, (int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()-30);		
					break;
					case 3:
						firstRect.setLocation((int)firstRect.getX()+30, (int) firstRect.getY()-30);
						this.get(1).setLocation((int)firstRect.getX()-30, (int) firstRect.getY()+30);
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(3).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
					break;
					}
			break;
			case 3:
				this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
				this.get(2).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()+30);
				this.get(3).setLocation((int)firstRect.getX(),(int) firstRect.getY()+30);			
			break;
			case 4:
				switch(state)
				{
					case 0:
						firstRect.setLocation((int)firstRect.getX()-30, (int) firstRect.getY());
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+90,(int) firstRect.getY());			
					break;
					case 1:
						firstRect.setLocation((int)firstRect.getX()+30, (int) firstRect.getY());	
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
						this.get(3).setLocation((int)firstRect.getX(), (int) firstRect.getY()+90);
					break;
					case 2:
						firstRect.setLocation((int)firstRect.getX()-30, (int) firstRect.getY());
						this.get(1).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+60, (int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+90, (int) firstRect.getY());		
					break;
					case 3:
						firstRect.setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
						this.get(2).setLocation((int)firstRect.getX(), (int) firstRect.getY()+60);
						this.get(3).setLocation((int)firstRect.getX(), (int) firstRect.getY()+90);
					break;
				}
			break;
			case 5:
				switch(state)
				{
					case 0:
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()+30);
						this.get(3).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()+30);
					break;
					case 1:
						this.get(1).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()-30);
						this.get(2).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
					break;
					case 2:
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
						this.get(2).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()+30);
						this.get(3).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()+30);
					break;
					case 3:
						this.get(1).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()-30);
						this.get(2).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX(), (int) firstRect.getY()+30);
					break;
				}										
			break;
			case 6:
				switch(state)
				{
					case 0:
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()-30);
						this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()-30);
						this.get(3).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
					break;
					case 1:
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()-30);
						this.get(2).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()+30);
					break;
					case 2:
						this.get(1).setLocation((int)firstRect.getX()+30,(int) firstRect.getY()-30);
						this.get(2).setLocation((int)firstRect.getX()+60,(int) firstRect.getY()-30);
						this.get(3).setLocation((int)firstRect.getX()+30,(int) firstRect.getY());
					break;
					case 3:
						this.get(1).setLocation((int)firstRect.getX(), (int) firstRect.getY()-30);
						this.get(2).setLocation((int)firstRect.getX()+30, (int) firstRect.getY());
						this.get(3).setLocation((int)firstRect.getX()+30, (int) firstRect.getY()+30);
					break;
				}
			break;
		}
	}
}