   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import javax.swing.Timer;
   import java.util.*;
   import java.io.*;
   import javax.swing.JOptionPane;
   import java.net.*;

    public class TetrisView extends JPanel
   {
      private TetrisGame game;
      private TetrisShape currShape;
      private Timer tetrisTimer;
      private ArrayList<TetrisShape> deadShapes = new ArrayList();
      private Color[] colors = new Color[7];
  		private int delay = 400;  
	    public TetrisView(TetrisGame g)
      {
         super();
			tetrisTimer = new Timer(400, new TetrisTimer());
			tetrisTimer.setDelay(tetrisTimer.getInitialDelay());
         colors[0] = Color.BLUE;
         colors[1] = Color.RED;
         colors[2] = Color.GREEN;
         colors[3] = Color.YELLOW;
         colors[4] = Color.ORANGE;
         colors[5] = Color.CYAN;
         colors[6] = Color.MAGENTA;
         setPreferredSize(new Dimension(300,600));
         game = g;
         setBackground(Color.BLACK);
         currShape = new TetrisShape();
         addMouseListener( 
                new MouseAdapter()
               {
                   public void mousePressed(MouseEvent e)
                  {
  							e.getComponent().requestFocusInWindow(); 
		               if(!tetrisTimer.isRunning())
                     {
                     //click to start
                        e.getComponent().requestFocusInWindow();
                     //start the game
                        tetrisTimer.start();
                     }
                  }
               });		
         addKeyListener(
                new KeyAdapter()
               {
                   public void keyReleased(KeyEvent e) 
                  {
                     int c = e.getKeyCode();
                     if (c == 39)
                     {
                     } 
                     if (c == 37)
                     {
                     } 
                     if (c == 40)
                     {
                     }		
                     if (c == 38)
                     {
                     }
                  }
                   public void keyPressed(KeyEvent e)
                  {
                     int c = e.getKeyCode();
                     if (tetrisTimer.isRunning())
                     {
                     if (c == 39)
                     {
                        if(canMoveRight())
                        currShape.moveRight();
                     //right
                     	testBottom();
                        repaint();
                     } 
                     if (c == 37)
                     {
                     	if(canMoveLeft())
                        currShape.moveLeft();
                     //left
                     	testBottom();
                        repaint();
                     } 
                     if (c == 40)
                     {
                     if (testBottom());
                     	currShape.moveDown();
                     //down
                     
                        repaint();
                     }		
                     if (c == 38)
                     {
                     	if(canRotate())
                        currShape.rotateShape();
                     //rotate
                     	testBottom();
                        repaint();
                     }
                     }			
                  }
               });
      }
   
   	 public boolean canRotate()
   	 {
   	 	currShape.rotateShape(); 
   		for (Rectangle r:currShape)
   		{
   			for (TetrisShape s:deadShapes)
   				for(Rectangle rc: s)
   					 if (rc.x == r.x && rc.y == r.y)
   					 {	
   						currShape.rotateShape(); 
   	 					currShape.rotateShape(); 
   	 					currShape.rotateShape(); 
   					 	return false;
   				    }
   			if (r.x >= 300 || r.x < 0)
				{
					currShape.rotateShape(); 
   				currShape.rotateShape(); 
   				currShape.rotateShape(); 
   			 	return false;	
				}
			}
   		currShape.rotateShape(); 
   	 	currShape.rotateShape(); 
   	 	currShape.rotateShape(); 
   
   		return true;
   	 }
   	 public boolean canMoveRight()
   	 {
   	 	Rectangle mostRight = new Rectangle(-10,-10, 1, 1);
   		boolean ret = true;
   		for (Rectangle r:currShape)
   		{
   			if (mostRight.x < r.x)
   				mostRight = r;
   		}	 
   		if (mostRight.x + 30 >= 300)
   			return false;
   		
   		for (Rectangle r:currShape)
   		{
   			for (TetrisShape s:deadShapes)
   			{
   				for (Rectangle rc: s)
   				{
   					if(r.x + 30 == rc.x && r.y == rc.y)
   					{	
   						return false;
   					}
   				}
   			}
   		}
   		
   		return ret;
   	 }
   	 public boolean canMoveLeft()
   	 {
   	 	Rectangle mostLeft = new Rectangle(800,800, 1, 1);
   		boolean ret = true;
   		for (Rectangle r:currShape)
   		{
   			if (mostLeft.x > r.x)
   				mostLeft = r;
   		}	 
   		if (mostLeft.x - 30 < 0)
   			return false;
   		
   		for (Rectangle r:currShape)
   		{
   			for (TetrisShape s:deadShapes)
   			{
   				for (Rectangle rc: s)
   				{
   					if(r.x - 30 == rc.x && r.y == rc.y)
   					{	
   						return false;
   					}
   				}
   			}
   		}
   		
   		return ret;
   	 }
       public void paintComponent(Graphics g)
      {
      
         g.setColor(Color.BLACK);
         g.fillRect(0,0, getWidth(), getHeight());
      
         Color tempCol = colors[currShape.getType()];
         for(Rectangle r:currShape)
         {
            g.setColor(tempCol);
            g.fillRect(r.x, r.y, r.height, r.width);
            g.setColor(tempCol.darker());
            g.drawRect(r.x, r.y, r.height, r.width);
         
         }
      
         for (TetrisShape s: deadShapes)
         {
            tempCol = colors[s.getType()];
            for (Rectangle r: s)
            {
               g.setColor(tempCol);
               g.fillRect(r.x, r.y, r.height, r.width);
               g.setColor(tempCol.darker());
               g.drawRect(r.x, r.y, r.height, r.width);
            
            }
         }
         if(!tetrisTimer.isRunning())
      		g.drawString("Click to start!", 150, 300);
      	
      }
   
   
       public boolean testBottom()
      {
         Rectangle lowest = currShape.get(0);
         ArrayList<Rectangle> lowests = new ArrayList();
         boolean newIt = false;
         for (Rectangle r:currShape)
         {
            if (r.y > lowest.y)
               lowest = r;				
         }
         for (Rectangle r:currShape)
         {
            if (r.y == lowest.y)
               lowests.add(r);
         }
         for (Rectangle r:lowests)
         {
            if (r.y + 30 == 600)
            {
               deadShapes.add(currShape);	
               newIt = true;
               break;
            }
            else if (r.y + 30 > 600)
            {
               currShape.moveUp();
               newIt = true;
               break;
            }
         }
         if (!newIt)
         {
            for (Rectangle r: currShape)
            {
               for (TetrisShape s: deadShapes)
               {
                  for(Rectangle rc: s)
                  {
                     if (r.getY() + 30 == rc.getY() && r.getX() == rc.getX())
                     {
                        deadShapes.add(currShape);
                        newIt = true;
                        break;
                     }
                  }
                  if (newIt)
                     break;
               }
               if (newIt)
                  break;
            }		
         }
         if (newIt)
         {
            testForRemove();
            currShape =  new TetrisShape();
      	}
         return !newIt;
      }
    	public void testForRemove()
   	{
   		boolean[][] space = new boolean[10][20];
   		for (int i = 0; i < 20; i++)
   			for (int j = 0; j < 10; j++)
   				space[j][i] = false;
   		
   		for (TetrisShape s:deadShapes)
   		{
   			for (Rectangle r: s)
   			{
   				if (r.y >= 0 && r.x >= 0)
   					space[r.x/30][r.y/30] = true;
   			}
   		}
			int rows = 1;
   		boolean row;
   		for(int i = 0; i < 20; i++)
   		{
				row = true;
   			for(int j = 0; j < 10; j++)
   			{	
					row = row && space[j][i];
   			}
   			if (row)
   			{
   				removeRow(i);
   				game.addLine();
   				rows++;
   			}
   		}
			
   		if (game.getLines() >= ((game.getLevel())*(game.getLevel()+1)/2)*5)
   		{
   			game.addLevel();
				delay -=10;
				tetrisTimer.setDelay(delay);
			}
   		game.addScore(rows*rows * 10);
   
   	}
   	public void removeRow(int row)
   	{
   		ArrayList<Rectangle> remRect = new ArrayList();
   		ArrayList<Rectangle> rectDown = new ArrayList();
   		for (TetrisShape s:deadShapes)
   		{
   			for (Rectangle r: s)
   			{
   				if(r.y/30 == row)
   					remRect.add(r);
   				if(r.y/30 < row)
   					rectDown.add(r);
   			}
   			for(Rectangle r:remRect)
   			{
   				s.remove(s.indexOf(r));				
   			}
   			remRect = new ArrayList();
   		}
   		for (Rectangle r: rectDown)
   			r.y+=30;
   	}	
   	public void testForRowsDown()
   	{
   		boolean[][] space = new boolean[10][20];
   		for (int i = 0; i < 20; i++)
   			for (int j = 0; j < 10; j++)
   				space[j][i] = false;		
   		
   		
   		for (TetrisShape s:deadShapes)
   		{
   			for (Rectangle r: s)
   			{
   				space[r.x/30][r.y/30] = true;
   			}
   		}
   		boolean temptop, templow;
   		for (int i = 0; i < 19; i++)
   		{
   			templow = false;
   			for (int j = 0; j < 10; j++)
   			{
   				templow = templow || space[j][i]; 
   				if (space[j][i] && !space[j][i+1])
   				{
   					moveDown(j);
   				}
   			}			 
   		}
   	}
   	public void moveDown(int y)
   	{
   		for (TetrisShape s:deadShapes)
   		{
   			for (Rectangle r: s)
   			{
   				if(r.y/30 >= y)
   					r.y+=30;
   			}
   		}	
   	}
   	public void loseTest()
   	{
   		for (TetrisShape s:deadShapes)
   		{
   			for (Rectangle r: s)
   			{
   				if(r.y < 0)
   					lose();
   			}
   		}	
   	}
   	public void lose()
   	{
   		tetrisTimer.stop();
   		deadShapes = new ArrayList();
   		currShape = new TetrisShape();
			delay = 400;
			tetrisTimer.setDelay(delay);
			game.reset();
   		repaint();
   	}
       public class TetrisTimer implements ActionListener
      {
          public void actionPerformed(ActionEvent e)
         {
         	if(testBottom())	
            	currShape.moveDown();
            repaint();
         	loseTest();
         }
      }
   
   }